"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Ajv = require("ajv");
var config_1 = require("./config");
var platforms = ['facebook', 'telegram', 'twilio', 'wechat', 'slack', 'slack-command', 'slack-event', "viber"];
var SchemaValidator = /** @class */ (function () {
    function SchemaValidator(schema) {
        this.schema = schema;
    }
    SchemaValidator.findOne = function (data) {
        return new Promise(function (resolve, reject) {
            var validator = new SchemaValidator(config_1.Config.schema);
            var facebook = validator.validate(platforms[0], data);
            var telegram = validator.validate(platforms[1], data);
            var twilio = validator.validate(platforms[2], data);
            var wechat = validator.validate(platforms[3], data);
            var slack = validator.validate(platforms[4], data);
            var slackCommand = validator.validate(platforms[5], data);
            var slackEvent = validator.validate(platforms[6], data);
            var viber = validator.validate(platforms[7], data);
            Promise.all([facebook, telegram, twilio, wechat, slack, slackCommand, slackEvent, viber]).then(function (results) {
                var index = results.indexOf(true);
                if (results.indexOf(true) >= 0)
                    resolve(platforms[index]);
                else
                    resolve("web");
            });
        });
    };
    SchemaValidator.prototype.validate = function (platform, data) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            resolve(_this.validateSchema(_this.schema[platform], data));
        });
    };
    SchemaValidator.prototype.validateSchema = function (schema, data) {
        var ajv = new Ajv();
        var validate = ajv.compile(schema);
        return validate(data);
    };
    return SchemaValidator;
}());
exports.SchemaValidator = SchemaValidator;
